<template>
    <div>
        <h1>{{titulo}}</h1>
        <b-form @submit.prevent="salvar" v-if="show">
            <b-row>
                <b-col sm=12>
                    <b-card>
                    <b-row>
                        <b-col sm=3>
                            <div id="cpf-group" role="group" class="form-group">
                                <label id="cpf-group" for="cpf" class="d-block">CPF</label>
                                <div>
                                    <input id="cpf" type="text" required="required" aria-required="true" class="form-control" v-model="form.cpf" v-mask="'###.###.###-##'">
                                </div>
                            </div>
                        </b-col>
                        <b-col sm="9">
                            <b-form-group
                                id="email-group"
                                label="Email/Login:"
                                label-for="email"
                            >
                                <b-form-input
                                    id="email"
                                    v-model="form.email"
                                    type="email"
                                    required/>
                            </b-form-group>
                        </b-col>
                    </b-row>
                    <b-row>
                        <b-col lg=12>
                            <b-form-group id="nome-group" label="Nome Completo:" label-for="nome">
                                <b-form-input
                                id="nome"
                                v-model="form.nome"
                                required/>
                            </b-form-group>
                        </b-col>
                    </b-row>
                    </b-card>
                </b-col>
            </b-row>
            <b-row>
                <b-col lg=12>
                    <b-card title="Acesso" class="mt-3">
                        <b-row>
                            <b-col sm=6>
                                <b-form-checkbox v-model="form.ativo" name="check-button" switch @change="limparPerfis">
                                    Ativo
                                </b-form-checkbox>
                                <hr/>
                                <b-form-group label="Perfis de acesso" v-slot="{ ariaDescribedby }">
                                    <b-form-checkbox-group
                                        v-model="form.perfis"
                                        :options="perfis"
                                        :aria-describedby="ariaDescribedby"
                                        plain
                                        stacked
                                    />
                                </b-form-group>
                            </b-col>

                            <b-col sm=6 v-if="isNew()">
                                <b-form-checkbox v-model="informarSenha" name="check-button" switch @change="limparCampoSenha">
                                    Informar senha?
                                </b-form-checkbox>
                                <hr/>
                                <b-form-group v-if="informarSenha"
                                    id="senha-group"
                                    label="Senha:"
                                    label-for="senha"
                                >
                                    <b-form-input
                                        id="senha"
                                        v-model="form.senha"
                                        type="password"
                                        required/>
                                </b-form-group>
                            </b-col>
                        </b-row>
                    </b-card>
                </b-col>
            <hr/>
            </b-row>
            <b-row class="mt-3">
                <b-col sm=12>
                    <b-button squared class="m-2" type="submit" variant="success">Salvar</b-button>
                    <b-button squared variant="secondary" @click="voltar">Voltar</b-button>
                </b-col>
            </b-row>
        </b-form>
    </div>
</template>

<script>
import axios from 'axios'

export default {
    name: 'Usuario',
    props: {
        id : { type: String, "default": null }
    },
    data(){
        return {
            form:{
                cpf: null,
                nome: null,
                email:null,
                ativo: true,
                senha: null,
                perfis:[]
            },
            perfis:[
                {text: 'Administrador', value:'ADMINISTRADOR' },
                {text: 'Cidadão', value:'CIDADAO' },
                {text: 'Operador de Prefeitura', value:'OPERADOR_PREFEITURA' },
                {text: 'Operador de Órgão Municipal', value:'OPERADOR_ORGAO_MUNICIPAL' },

            ],
            show:true,
            informarSenha: false
        }
    }, 
    created() {
        if(!this.isNew()) {
            const config = {
            headers:{ Authorization: this.$store.state.token}
            }
            axios.get(`http://localhost:5555/identity/users/${this.$props.id}`, config)
                .then(({data}) =>  this.form = data)
                .catch((err) => {
                    let message = 'Erro ao tentar recuperar usuário para alteração'
                    if(err.message) { message = err.message}
                    this.$toastr.e(message)
                })
        }
    },
    methods:{
        salvar() {
            let cpfFormatado = this.form.cpf;
            this.form.cpf = cpfFormatado.replace(/\.|-|\//g, "");
            let form = Object.assign({}, this.form)
            this.form.cpf = cpfFormatado;

            const url = 'http://localhost:5555/identity/users'
            const config = {
              headers:{ Authorization: this.$store.state.token}
            }
            if(this.isNew()) {
               this.incluir(url, form, config) 
            } else {
               this.alterar(`${url}/${this.$props.id}`, form, config)
            }
        },
        incluir(url, form, config) {
            axios.post(url, form, config)
                .then(() => {
                    this.$toastr.s ("Usuário adicionado com sucesso")
                    this.voltar()
                })
                .catch(({response}) => this.tratarErroResposta(response, 'Erro ao adicionar usuário'))
        },
        alterar(url, form, config) {
            axios.put(url, form, config)
                .then(() => {
                    this.$toastr.s ("Usuário alterado com sucesso")
                    this.voltar()
                })
               .catch(({response}) => this.tratarErroResposta(response, 'Erro ao alterar usuário'))
        },
        voltar() {
            this.$router.push("/auth/usuarios")
        },
        limparCampoSenha(){
            if(!this.informarSenha) { this.form.senha = null}
        },
        limparPerfis(){
            if(!this.form.ativo){ this.form.perfis = []}
        },
        isNew() {
            return this.$props.id === 'novo'
        },
        tratarErroResposta(response, mensagemGenerica) {
            const erros = response.data.erros;
            if(erros) {
                erros.forEach(erro => {
                    if(erro.campo) {
                        this.$toastr.e(`O campo '${erro.campo}' ${erro.erro}`)
                    } else {
                        this.$toastr.e(`${erro.erro}`)
                    }                        
                });
            } else {
                this.$toastr.e(mensagemGenerica)
            }
        }
    },
    computed:{
        titulo() {
            return this.isNew()? 'Incluir usuário':'Alterar usuário'
        }
    }
}
</script>